#include "Paint_objects.h"
#include "Paint_resources.h"

//--------------------- User code ---------------------//
const unsigned int CL_SELECTED = 0x632C;

typedef struct t_drawingTool{
  unsigned int pen_size;
  unsigned short EraserSelected;
  TBox *CurrentPen;
  TBox *PreviousPen;
  
  TBox *CurrentColor;
  TBox *PreviousColor;
};

extern unsigned int Xcoord, Ycoord;
bit Bucket_Selected;

struct t_drawingTool drawingTool;

static void UpdatePenSelection(){
  drawingTool.CurrentPen->Pen_Color = CL_SELECTED;

  if (bucket_Selected) {
    Pen4.Pen_Color = CL_SELECTED;
    DrawBox(&Pen4);
  }
  else {
    if (drawingTool.PreviousPen > 0)
      drawingTool.PreviousPen->Pen_Color = Screen1.Color;
    DrawBox(&Pen1);
    DrawBox(&Pen2);
    DrawBox(&Pen3);
    Pen4.Pen_Color = CL_SILVER;
    DrawBox(&Pen4);
  }
  TFT_Set_Pen(drawingTool.CurrentColor->Color, 0);
  TFT_Set_Brush(1, drawingTool.CurrentColor->Color, 0, 0, 0, 0);
}

static void UpdatePenColor(){
  drawingTool.CurrentColor->Pen_Color = CL_SELECTED;
  DrawBox(drawingTool.CurrentColor);

  if (drawingTool.PreviousColor > 0){
    drawingTool.PreviousColor->Pen_Color = Screen1.Color;
    DrawBox(drawingTool.PreviousColor);
  }
  
  if (drawingTool.EraserSelected){
    Pen1.Color = Box1.Color;
    Pen2.Color = Box1.Color;
    Pen3.Color = Box1.Color;
  }
  else{
    Pen1.Color = drawingTool.CurrentColor->Color;
    Pen2.Color = drawingTool.CurrentColor->Color;
    Pen3.Color = drawingTool.CurrentColor->Color;
  }
  UpdatePenSelection();
}

void SetDefaults(){
  drawingTool.pen_size = 3;
  drawingTool.PreviousPen = 0;
  drawingTool.CurrentPen  = &Pen2;
  drawingTool.PreviousColor = 0;
  drawingTool.CurrentColor = &Box3;
  drawingTool.EraserSelected = 0;
  Bucket_Selected = 0;
  SelectPenPress();
  UpdatePenColor();
}
//----------------- End of User code ------------------//

// Event Handlers

void Box1Press() {
  // Draw Area
  if ((Xcoord >= Box1.Left+drawingTool.pen_size+1) && (Ycoord >= Box1.Top+drawingTool.pen_size+1)){
    if (drawingTool.EraserSelected){
      TFT_Set_Pen(Box1.Color, 0);
      TFT_Set_Brush(1, Box1.Color, 0, 0, 0, 0);
    }
    TFT_Circle(Xcoord, Ycoord, drawingTool.pen_size);
  }  
}

void Box2Press() {
  // White
  if (Bucket_Selected) {
    Pen4.Color = Box2.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box2){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box2;
  }
  updatePenColor();
}

void Box3Press() {
  // Black
  if (Bucket_Selected) {
    Pen4.Color = Box3.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box3){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box3;
  }
  updatePenColor();
}

void Box4Press() {
  // Pink
  if (Bucket_Selected) {
    Pen4.Color = Box4.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box4){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box4;
  }
  updatePenColor();
}

void Box5Press() {
  // Red
  if (Bucket_Selected) {
    Pen4.Color = Box5.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box5){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box5;
  }
  updatePenColor();
}

void Box6Press() {
  // Orange
  if (Bucket_Selected) {
    Pen4.Color = Box6.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box6){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box6;
  }
  updatePenColor();
}

void Box7Press() {
  // Yellow
  if (Bucket_Selected) {
    Pen4.Color = Box7.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box7){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box7;
  }
  updatePenColor();
}

void Box8Press() {
  // Green
  if (Bucket_Selected) {
    Pen4.Color = Box8.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box8){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box8;
  }
  updatePenColor();
}

void Box9Press() {
  // Aqua
  if (Bucket_Selected) {
    Pen4.Color = Box9.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box9){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box9;
  }
  updatePenColor();
}

void Box10Press() {
  // Blue
  if (Bucket_Selected) {
    Pen4.Color = Box10.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box10){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box10;
  }
  updatePenColor();
}

void Box11Press() {
  // Purple
  if (Bucket_Selected) {
    Pen4.Color = Box11.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box11){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box11;
  }
  updatePenColor();
}

void Box12Press() {
  // Dark Purple
  if (Bucket_Selected) {
    Pen4.Color = Box12.Color;
    Bucket_Selected = 0;
    DrawBox(&Pen4);
  }
  else if (drawingTool.CurrentColor != &Box12){
    drawingTool.PreviousColor = drawingTool.CurrentColor;
    drawingTool.CurrentColor = &Box12;
  }
  updatePenColor();
}

void SelectPenPress() {
  // Select Pen
  if (drawingTool.EraserSelected != 0){
    drawingTool.EraserSelected = 0;
    updatePenColor();
  }
}

void Image1Click() {
  // New
  DrawBox(&Box1);
  UpdatePenColor();
}

void SelectEraserPress() {
  // Eraser
  if (drawingTool.EraserSelected != 1){
    drawingTool.EraserSelected = 1;
    updatePenColor();
  }
}

void BackgroundColorPress() {
  // Background Color Fill
  Box1.Color = Pen4.Color;
  DrawBox(&Box1);
  updatePenColor();
}

void Pen1Press() {
  // Size 3
  if (drawingTool.CurrentPen != &Pen1){
    drawingTool.pen_size = 6;
    drawingTool.PreviousPen = drawingTool.CurrentPen;
    drawingTool.CurrentPen = &Pen1;
    UpdatePenSelection();
  }
}

void Pen2Press() {
  // Size 2
  if (drawingTool.CurrentPen != &Pen2){
    drawingTool.pen_size = 4;
    drawingTool.PreviousPen = drawingTool.CurrentPen;
    drawingTool.CurrentPen = &Pen2;
    UpdatePenSelection();
  }
}

void Pen3Press() {
  // Size 1
  if (drawingTool.CurrentPen != &Pen3){
    drawingTool.pen_size = 2;
    drawingTool.PreviousPen = drawingTool.CurrentPen;
    drawingTool.CurrentPen = &Pen3;
    UpdatePenSelection();
  }
}

void Pen4Press() {
  // Background fill color
  Bucket_Selected = 1;
  UpdatePenSelection();
}
