typedef struct Screen TScreen;

typedef struct  Label {
  char          Order;
  TScreen       *OwnerScreen;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const far char    *FontName;
  unsigned int  Font_Pos_Ver;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct  Image {
  TScreen       *OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  unsigned int  PictureWidth;
  unsigned int  PictureHeight;
  const far char    *Picture_Name;
  char          Visible;
  char          Active;
  char          AutoSize;
  char          Picture_Type;
  char          Picture_Ratio;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TImage;

typedef struct  Box {
  TScreen       *OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned short         ObjectsCount;
  unsigned int           LabelsCount;
  TLabel                 **Labels;
  unsigned int           ImagesCount;
  TImage                 **Images;
  unsigned int           BoxesCount;
  TBox                   **Boxes;
};

extern   TScreen                Screen1;
extern   TImage                 Mute;
extern   TImage                 Pause;
extern   TImage                 Header;
extern   TBox                   Box1;
extern   TImage                 Previous;
extern   TImage                 Stop;
extern   TImage                 Next;
extern   TImage                 Volume;
extern   TImage                 Play;
extern   TImage                 Volume_Bar;
extern   TBox                   VolumeBar;
extern   TLabel                 Label1;
extern   TLabel                 Label2;
extern   TLabel                 Label3;



/////////////////////////
// Events Code Declarations
void MuteClick();
void PauseClick();
void HeaderClick();
void PreviousClick();
void StopClick();
void NextClick();
void VolumeClick();
void PlayClick();
void VolumeBarChange();
void VolumeBarChange();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *Alabel);
void DrawImage(TImage *Aimage);
void DrawBox(TBox *Abox);
void Check_TP();
void Start_TP();
